# Copyright (c) 2011, Canonical Ltd
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation, version 3 only.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
# GNU Lesser General Public License version 3 (see the file LICENSE).

"""Tests for the publishers module."""

__metaclass__ = type

import testtools
from testtools.matchers import Is

from oops import publish_new_only

class TestPublishers(testtools.TestCase):

    def test_publish_new_only_id_in_report(self):
        def pub_fail(report):
            self.fail('publication called')
        publisher = publish_new_only(pub_fail)
        publisher({'id': 'foo'})

    def test_publish_new_only_no_id_in_report(self):
        calls = []
        publisher = publish_new_only(calls.append)
        publisher({'foo': 'bar'})
        self.assertEqual([{'foo': 'bar'}], calls)
